import request from '@/utils/request';
import type {ApiResult, PageResult} from '@/api';
import type {RentRecord, RentRecordParam} from './model';

/**
 * 分页查询结算
 */
export async function pageRentRecord(params: RentRecordParam) {
  const res = await request.get<ApiResult<PageResult<RentRecord>>>(
    '/tower/tower-rent-record/page',
    {
      params
    }
  );
  if (res.data.code === 0) {
    return res.data.data;
  }
  return Promise.reject(new Error(res.data.message));
}

/**
 * 查询合同列表
 */
export async function listRentRecord(params?: RentRecordParam) {
  const res = await request.get<ApiResult<RentRecord[]>>(
    '/tower/tower-rent-record',
    {
      params
    }
  );
  if (res.data.code === 0 && res.data.data) {
    return res.data.data;
  }
  return Promise.reject(new Error(res.data.message));
}

/**
 * 根据id查询合同
 */
export async function getRentRecord(id: number) {
  const res = await request.get<ApiResult<RentRecord>>(
    '/tower/tower-rent-record/' + id
  );
  if (res.data.code === 0 && res.data.data) {
    return res.data.data;
  }
  return Promise.reject(new Error(res.data.message));
}

/**
 * 添加合同
 */
export async function addRentRecord(data: RentRecord) {
  const res = await request.post<ApiResult<unknown>>(
    '/tower/tower-rent-record',
    data
  );
  if (res.data.code === 0) {
    return res.data;
  }
  return Promise.reject(new Error(res.data.message));
}

/**
 * 修改合同
 */
export async function updateRentRecord(data: RentRecord) {
  const res = await request.put<ApiResult<unknown>>(
    '/tower/tower-rent-record',
    data
  );
  if (res.data.code === 0) {
    return res.data;
  }
  return Promise.reject(new Error(res.data.message));
}

/**
 * 批量修改合同
 */
export async function updateBatchRentRecord(data: RentRecord[]) {
  const res = await request.put<ApiResult<unknown>>(
    '/tower/tower-rent-record/batch',
    data
  );
  if (res.data.code === 0) {
    return res.data.message;
  }
  return Promise.reject(new Error(res.data.message));
}
export async function addBatchRentRecord(data: RentRecord[]) {
  const res = await request.post<ApiResult<unknown>>(
    '/tower/tower-rent-record/batch',
    data
  );
  if (res.data.code === 0) {
    return res.data.message;
  }
  return Promise.reject(new Error(res.data.message));
}

/**
 * 删除合同
 */
export async function removeRentRecord(id?: number) {
  const res = await request.delete<ApiResult<unknown>>(
    '/tower/tower-rent-record/' + id
  );
  if (res.data.code === 0) {
    return res.data.message;
  }
  return Promise.reject(new Error(res.data.message));
}

/**
 * 批量删除合同
 */
export async function removeBatchRentRecord(data: (number | undefined)[]) {
  const res = await request.delete<ApiResult<unknown>>(
    '/tower/tower-rent-record/batch',
    {
      data
    }
  );
  if (res.data.code === 0) {
    return res.data.message;
  }
  return Promise.reject(new Error(res.data.message));
}
